## 配置文件

配置文件大致和常规战斗一样.

例如:

```yaml
# E10 AD 双连夜战练级
# 均速 A点战列大于等于1，D点重巡大于等于2
chapter: H
map: 4
selected_nodes: [A, D]
node_defaults:
  proceed: True
  formation: 4
  SL_when_enter_fight: True
```


map 参数为 1~6, chapter 参数为 `E` 或者 `H` 分别表示简单和困难.

## 使用

以下是函数原型:

AutoWSGR.fight.event.event_2023_0613.EventFightPlan20230809

```python
class EventFightPlan20230809(Event, NormalFightPlan):

    def __init__(self, timer: Timer, plan_path, fleet_id=None, event="20230809"):
        """
        Args:
            fleet_id : 新的舰队参数, 优先级高于 plan 文件, 如果为 None 则使用计划参数.

        """
```

你可能需要填的参数只有 "plan_path", "fleet_id".

使用示例, 位于本项目地址 `/examples/event_20230809.py`:

```python
from AutoWSGR.fight.event.event_2023_0613 import EventFightPlan20230613
from AutoWSGR.scripts.main import start_script

timer = start_script()
plan = EventFightPlan20230809(timer, "event/20230809/E10AD.yaml", fleet_id=4)
plan.run_for_times(500)
```

我们提供了两个默认文件, 位于本项目 `/src/AutoWSGR/data/plans/event/20230809`, 你可以直接使用它们.
