## 配置文件

配置文件大致和常规战斗一样, 参数多一个 "from_alpha", 这个参数用于指定入口.

例如:

```yaml
# E10 DE 双连夜战练级
# 均速 >=30 BB >= 1
chapter: H
map: 4
selected_nodes: [D, E]
from_alpha: False
node_defaults:
  proceed: True
  formation: 4
  SL_when_enter_fight: True
```

"from_alpha" 参数为 "True" 时从 alpha 点进入, 否则从 beta 点进入.

map 参数为 1~6, chapter 参数为 `E` 或者 `H` 分别表示简单和困难.

## 使用

以下是函数原型:

AutoWSGR.fight.event.event_2023_0613.EventFightPlan20230613

```python
class EventFightPlan20230613(Event, NormalFightPlan):

    def __init__(self, timer: Timer, plan_path, from_alpha=True, fleet_id=None, event="20230613"):
        """
        Args:
            fleet_id : 新的舰队参数, 优先级高于 plan 文件, 如果为 None 则使用计划参数.

            from_alpha : 指定入口, 默认为 True 表示从 alpha 进入, 如果为 False 则从 beta 进入, 优先级高于 plan 文件, 如果为 None 则使用计划文件的参数.
        """
```

你可能需要填的参数只有 "plan_path", "from_alpha".

使用示例, 位于本项目地址 `/examples/event0613.py`:

```python
from AutoWSGR.fight.event.event_2023_0613 import EventFightPlan20230613
from AutoWSGR.scripts.main import start_script

timer = start_script()
plan = EventFightPlan20230613(timer, "event/20230613/E10D.yaml", fleet_id=3)
plan.run_for_times(100)
```

我们提供了两个默认文件, 位于本项目 `/src/AutoWSGR/data/plans/event/20230613`, 你可以直接使用它们.
